searchNodes=[{"ref":"EctoList.html","title":"EctoList","type":"module","doc":"Implements conveniences to handle the items order of a list."},{"ref":"EctoList.html#complete_items_order/2","title":"EctoList.complete_items_order/2","type":"function","doc":"Returns the list of ids composed of the current list order + all the missings ids ordered by insertion date. Examples all_items = [%{id: 1, title: &quot;Item 1&quot;, inserted_at: ~N[2019-07-16 16:03:15]}, %{id: 2, title: &quot;Item 2&quot;, inserted_at: ~N[2019-07-16 16:04:15]}, %{id: 3, title: &quot;Item 3&quot;, inserted_at: ~N[2019-07-16 16:05:15]}, %{id: 4, title: &quot;Item 4&quot;, inserted_at: ~N[2019-07-16 16:06:15]}, %{id: 5, title: &quot;Item 5&quot;, inserted_at: ~N[2019-07-16 16:07:15]}] items_order = [5, 3, 1] complete_items_order(all_items, items_order) # [5, 3, 1, 2, 4]"},{"ref":"EctoList.html#missing_ids_list/1","title":"EctoList.missing_ids_list/1","type":"function","doc":"Same as missing_ids_list/2 but returns all ids ordered by insertion date."},{"ref":"EctoList.html#missing_ids_list/2","title":"EctoList.missing_ids_list/2","type":"function","doc":"Returns the list of missing ids ordered by insertion date. Examples all_items = [%{id: 1, title: &quot;Item 1&quot;, inserted_at: ~N[2019-07-16 16:03:15]}, %{id: 2, title: &quot;Item 2&quot;, inserted_at: ~N[2019-07-16 16:04:15]}, %{id: 3, title: &quot;Item 3&quot;, inserted_at: ~N[2019-07-16 16:05:15]}, %{id: 4, title: &quot;Item 4&quot;, inserted_at: ~N[2019-07-16 16:06:15]}, %{id: 5, title: &quot;Item 5&quot;, inserted_at: ~N[2019-07-16 16:07:15]}] items_order = [5, 3, 1] missing_ids_list(all_items, items_order) # [2, 4]"},{"ref":"EctoList.html#ordered_items_list/2","title":"EctoList.ordered_items_list/2","type":"function","doc":"Returns the list of items ordered according to the items_order list. If ids are missing in items_order, the items will be ordered according to their inserted date. Examples all_items = [%{id: 1, title: &quot;Item 1&quot;, inserted_at: ~N[2019-07-16 16:03:15]}, %{id: 2, title: &quot;Item 2&quot;, inserted_at: ~N[2019-07-16 16:04:15]}, %{id: 3, title: &quot;Item 3&quot;, inserted_at: ~N[2019-07-16 16:05:15]}, %{id: 4, title: &quot;Item 4&quot;, inserted_at: ~N[2019-07-16 16:06:15]}, %{id: 5, title: &quot;Item 5&quot;, inserted_at: ~N[2019-07-16 16:07:15]}] items_order = [5, 3, 1] ordered_items_list(all_items, items_order) # [%{id: 5, title: &quot;Item 5&quot;, inserted_at: ~N[2019-07-16 16:07:15]}, # %{id: 3, title: &quot;Item 3&quot;, inserted_at: ~N[2019-07-16 16:05:15]}, # %{id: 1, title: &quot;Item 1&quot;, inserted_at: ~N[2019-07-16 16:03:15]}, # %{id: 2, title: &quot;Item 2&quot;, inserted_at: ~N[2019-07-16 16:04:15]}, # %{id: 4, title: &quot;Item 4&quot;, inserted_at: ~N[2019-07-16 16:06:15]}]"},{"ref":"EctoList.Context.html","title":"EctoList.Context","type":"module","doc":"Implements conveniences to manipulate the items order list. You can implement all the functions available in this module by using this module inside of the context of the List module. (Check the guides to see how) There are two functions in this module: sync_order_list/1 and reset_order_list/1 They both take a List struct that you define when calling &quot;use&quot;. sync_order_list/1 : will add missing ids to the items order list of the list. reset_order_list/1 : will set the items order as the list of ids ordered by inserted date."},{"ref":"readme.html","title":"ecto_list","type":"extras","doc":"ecto_list Ecto_list is a simple library that helps you manage ordered model with Ecto."},{"ref":"readme.html#description","title":"ecto_list - Description","type":"extras","doc":"Let&#39;s take an example of an ordered model: a Serie which contains an ordered list of videos. Instead of storing the position of each video in the videos themselves, we will store the ordering in the serie and we will call EctoList.ordered_items_list/2 to return for us the list of items properly ordered."},{"ref":"readme.html#installation","title":"ecto_list - Installation","type":"extras","doc":"Read the tutorial to understand the process of installation of the library."},{"ref":"readme.html#demo","title":"ecto_list - Demo","type":"extras","doc":"See the demo here."},{"ref":"readme.html#documentation","title":"ecto_list - Documentation","type":"extras","doc":"The documentation can be found here: https://hexdocs.pm/ecto_list."},{"ref":"tutorial.html","title":"Tutorial","type":"extras","doc":"Tutorial The goal of this tutorial is to explain you how to setup ecto_list. We will use a basic example to make the process clearer. We will build a simple Serie/Video app, it will be called... drum roll 🥁 ... Netflix . A Serie is a set of videos with a certain order. 1) Generating the model We will run the generators for our models: Series and Videos. mix phx.gen.html Series Serie series title items_order:array:id mix phx.gen.html Videos Video videos title serie_id:references:series We will store the videos order inside the serie with the field :items_order. In this example, we decide to call it &quot;items_order&quot; but you can change the name as you wish. Also, we didn&#39;t care much about the name of the context so we created a separate context for each model but you could definitely put them together in the same context. 2) Run migration Run the migration with mix ecto.migrate. Add the following lines in the router: resources &quot;/series&quot;, SerieController resources &quot;/videos&quot;, VideoController 3) Change schemas Add the right relationships to the models. In the Serie schema module Netflix.Series.Serie, add a default to items_order: defmodule Netflix.Series.Serie do # ... + alias Netflix.Videos.Video schema &quot;lists&quot; do field :title, :string - field :items_order, {:array, :id} + field :items_order, {:array, :id}, default: [] + has_many :videos, Video timestamps() end @doc false def changeset(video, attrs) do video - |&gt; cast(attrs, [:title]) - |&gt; validate_required([:title]) + |&gt; cast(attrs, [:title, :serie_id]) + |&gt; validate_required([:title, :serie_id]) end end defmodule Netflix.Videos.Video do # ... + alias Netflix.Series.Serie schema &quot;videos&quot; do field :title, :string - field :serie_id, :id + belongs_to :serie, Serie timestamps() end # ... end 4) Install ecto_list Add ecto_list to your list of dependencies in mix.exs (you can check the last version on hex.pm). def deps do [ # ... {:ecto_list, &quot;~&gt; 0.1.0&quot;} # ... ] end 5) use EctoList.Context You can use the EctoList.Context module to add Context functions to the Serie Context. defmodule Netflix.Series do @moduledoc &quot;&quot;&quot; The Series context. &quot;&quot;&quot; import Ecto.Query, warn: false alias Netflix.Repo alias Netflix.Series.Serie + use EctoList.Context, + list: Serie, + repo: Repo, + list_items_key: :videos, + items_order_key: :items_order Options: list: the schema containing the list of items. Here it is Serie because each Serie can contain a list of Videos. repo: the Repo module of the app list_items_key: the key used in the has_many relationship to access the list of items items_order_key: the key used in the field that contains the items order. Here it&#39;s items_order because that&#39;s how we decided to call it. 6) Preload videos Add Repo.preload/2 to load the videos while fetching for a specific serie. - def get_serie!(id), do: Repo.get!(Serie, id) + def get_serie!(id), do: Repo.get!(Serie, id) |&gt; Repo.preload(:videos) 7) Change show action (SerieController) In the show action of the Serie Controller, add a call to EctoList.ordered_items_list/2 which will return the list of videos ordered according the list of ids set in second position of entries. The first entry is the list of items set in the has_many relationship. The second entry is the list of ids which corresponds to the items order. defmodule NetflixWeb.SerieController do #... def show(conn, %{&quot;id&quot; =&gt; id}) do serie = Series.get_serie!(id) + videos = EctoList.ordered_items_list(serie.videos, serie.items_order) - render(conn, &quot;show.html&quot;, serie: serie) + render(conn, &quot;show.html&quot;, serie: serie, videos: videos) end #... end 8) Change show template In the show template of Serie, add the following lines: &lt;h1&gt;Show Serie&lt;/h1&gt; &lt;ul&gt; &lt;li&gt; &lt;strong&gt;Title:&lt;/strong&gt; &lt;%= @serie.title %&gt; &lt;/li&gt; &lt;li&gt; &lt;strong&gt;Items order:&lt;/strong&gt; &lt;%= @serie.items_order %&gt; &lt;/li&gt; + &lt;%= for video &lt;- @videos do %&gt; + &lt;div&gt; + &lt;%= video.title %&gt; + &lt;/div&gt; + &lt;% end %&gt; &lt;/ul&gt; &lt;span&gt;&lt;%= link &quot;Edit&quot;, to: Routes.serie_path(@conn, :edit, @serie) %&gt;&lt;/span&gt; &lt;span&gt;&lt;%= link &quot;Back&quot;, to: Routes.serie_path(@conn, :index) %&gt;&lt;/span&gt; 9) Change edit and update action (SerieController) Back at the Serie controller, add the following lines to the edit and to the update action: defmodule NetflixWeb.SerieController do #... def edit(conn, %{&quot;id&quot; =&gt; id}) do serie = Series.get_serie!(id) + videos = EctoList.ordered_items_list(serie.videos, serie.items_order) changeset = Series.change_serie(serie) - render(conn, &quot;edit.html&quot;, serie: serie, changeset: changeset) + render(conn, &quot;edit.html&quot;, serie: serie, videos: videos, changeset: changeset) end - def update(conn, %{&quot;id&quot; =&gt; id, &quot;serie&quot; =&gt; serie_params}) do + def update(conn, %{&quot;id&quot; =&gt; id, &quot;serie&quot; =&gt; serie_params, &quot;items_order&quot; =&gt; items_order}) do serie = Series.get_serie!(id) + serie_params = Map.put(serie_params, &quot;items_order&quot;, items_order) case Series.update_serie(serie, serie_params) do {:ok, serie} -&gt; conn |&gt; put_flash(:info, &quot;Serie updated successfully.&quot;) |&gt; redirect(to: Routes.serie_path(conn, :show, serie)) {:error, %Ecto.Changeset{} = changeset} -&gt; render(conn, &quot;edit.html&quot;, serie: serie, changeset: changeset) end end #... end 10) Change form template for edit action Inside the form template of serie, add those changes: &lt;%= form_for @changeset, @action, fn f -&gt; %&gt; &lt;%= if @changeset.action do %&gt; &lt;div class=&quot;alert alert-danger&quot;&gt; &lt;p&gt;Oops, something went wrong! Please check the errors below.&lt;/p&gt; &lt;/div&gt; &lt;% end %&gt; &lt;%= label f, :title %&gt; &lt;%= text_input f, :title %&gt; &lt;%= error_tag f, :title %&gt; - &lt;%= label f, :items_order %&gt; - &lt;%= multiple_select f, :items_order, [&quot;Option 1&quot;: &quot;option1&quot;, &quot;Option 2&quot;: &quot;option2&quot;] %&gt; - &lt;%= error_tag f, :items_order %&gt; + &lt;%= if @view_template == &quot;edit.html&quot; do %&gt; + &lt;div&gt; + &lt;%= for video &lt;- @videos do %&gt; + &lt;div&gt; + &lt;%= hidden_input f, :items_order, name: &quot;items_order[]&quot;, value: video.id %&gt; + &lt;%= video.id %&gt; - &lt;%= video.title %&gt; + &lt;/div&gt; + &lt;% end %&gt; + &lt;/div&gt; + &lt;% end %&gt; &lt;div&gt; &lt;%= submit &quot;Save&quot; %&gt; &lt;/div&gt; &lt;% end %&gt; We made a simple if condition to add this block of code only if we are in the edit action because the form is shared also for the new action. 11) Create sample data to test We can add some data so that we can see what we get now. Inside the iex console, run: Netflix.Series.create_serie(%{title: &quot;Serie 1&quot;}) Netflix.Videos.create_video(%{title: &quot;Video 1&quot;, serie_id: 1}) Netflix.Videos.create_video(%{title: &quot;Video 2&quot;, serie_id: 1}) Netflix.Videos.create_video(%{title: &quot;Video 3&quot;, serie_id: 1}) If you go to &quot;/series&quot; and click the first serie, you&#39;ll get the list of the 3 videos we created. Now, we will add a drag and drop library so that we can change the order. 12) Install Drag&amp;Drop library For this example, I will use draggable, a library made by Shopify but you can use whatever drag and drop library. In the terminal, go to the assets folder and run npm i @shopify/draggable. In assets/js, create a file called &quot;ectoListSorting.js&quot; and add this content. import { Sortable } from &quot;@shopify/draggable&quot;; export default function ectoListSorting() { const containerSelector = &quot;.StackedList&quot;; const containers = document.querySelectorAll(containerSelector); new Sortable(containers, { draggable: &quot;.StackedListItem&quot;, mirror: { appendTo: containerSelector, constrainDimensions: true } }); } In assets/js/app.js, add the following lines: // ... import &quot;phoenix_html&quot;; + import ectoListSorting from &quot;./ectoListSorting&quot;; + ectoListSorting(); // ... Now back to the edit form of serie (templates/serie/form.html.eex), add the following changes: &lt;%= if @view_template == &quot;edit.html&quot; do %&gt; - &lt;div&gt; + &lt;div class=&quot;StackedList&quot;&gt; &lt;%= for video &lt;- @videos do %&gt; - &lt;div&gt; + &lt;div class=&quot;StackedListItem&quot;&gt; &lt;%= hidden_input f, :items_order, name: &quot;items_order[]&quot;, value: video.id %&gt; &lt;%= video.id %&gt; - &lt;%= video.title %&gt; &lt;/div&gt; &lt;% end %&gt; &lt;/div&gt; &lt;% end %&gt; &lt;div&gt; &lt;%= submit &quot;Save&quot; %&gt; &lt;/div&gt; Now, you can drag and drop the videos of a serie and save the modified order."},{"ref":"tutorial.html#conclusion","title":"Tutorial - Conclusion","type":"extras","doc":"There is still a lot of code copy pasting but it&#39;s worth it because you have the control of your code. This library is pretty basic. The most important function is EctoList.ordered_items_list/2 that render the list of items in the appropriate order."}]